#!/usr/bin/perl

$cd = $ARGV[0];

if ($cd =~ /^$/) {
	die "Usage: $0 <CD-Name>   -   Program execution stopped";
}

print "CD-Title: $cd\n";

# Its based on an MYSQL DB, so do not change, unless you know
# what you are doing
$driver = "mysql";

require("PATH/storemp3.conf");

printf("$mp3db");

$dsn = "DBI:$driver:database=$mp3db:host=$host;$options";

use POSIX qw(locale_h strftime);
use DBI;
use MPEG::MP3Info;
use MPEG::MP3Info qw(:genres);
use MPEG::MP3Info qw(:DEFAULT :genres);
use MPEG::MP3Info qw(:all);


$dbh = DBI->connect($dsn, $user, $passwd);

if ( !defined $dbh ) {
    die "Cannot connect to the mySQL server: $DBI::errstr\n";
  }
 
$drh = DBI->install_driver("mysql");

$cd = $dbh->quote($cd);

#-----------

while ($arg=<stdin>) {
	chop($arg);
	$arg =~ s/^.\///g;
	($quoted = $arg) =~ s/`/\\`/g;
	@filedirs = split(/\//, $arg);
	$filename = splice(@filedirs, $#filedirs, 1);
	$dirname = join('/', @filedirs);

	print "filename: $filename - Dir: $dirname\n";
	$title = '';
	$artist = '';
	$album = '';
	$year = '';
	$comment = '';
	$genre = '';
	$info = get_mp3info($arg);
	print "Determining quality\n";
	printf "Minutes: $info->{MM}\n";
	printf "Seconds: $info->{SS}\n";
	printf "Version: $info->{VERSION}\n";
	printf "Stereo: $info->{STEREO}\n";
	printf "Layer: $info->{LAYER}\n";
	printf "Bitrate: $info->{BITRATE}\n";
	printf "Mode: $info->{MODE}\n";
	printf "Copyright: $info->{COPYRIGHT}\n";
	printf "Frequency: $info->{FREQUENCY}\n";
	printf "Mode: $info->{MODE}\n";

	$minutes = $info->{MM};
	$seconds = $info->{SS};
	$version = $info->{VERSION};
	$stereo = $info->{STEREO};
	$layer = $info->{LAYER};
	$rate = $info->{BITRATE};
	$mode = $info->{MODE};

# Modes:
# 0: stereo
# 1: j-stereo
# 2: dual-ch
# 3: single-ch
	
	$copyright = $info->{COPYRIGHT};
	$frequency = $info->{FREQUENCY};
	$mode = $info->{MODE};
	
	if ($seconds < 10) {
		$length = "00:$minutes:0$seconds";
	} else {
		$length = "00:$minutes:$seconds";
	}
	print "Length: $length\n";
	
	$tag = get_mp3tag($arg) or goto savetodb;
	$title = $tag->{TITLE};
	$artist = $tag->{ARTIST};
	$album = $tag->{ALBUM};
	$year = $tag->{YEAR};
	$comment = $tag->{COMMENT};
	$genre = $tag->{GENRE};
	$track = $tag->{TRACKNUM};

	print "Title: $title\n";
	print "Artist: $artist\n";
	print "album: $album\n";
	print "year: $year\n";
	print "genre: $genre\n";
	print "comment: $comment\n";
	
savetodb:	
	$filename = $dbh->quote("" . $filename);
	$dirname = $dbh->quote("" . $dirname);
	$title = $dbh->quote("" . $title);
	$artist = $dbh->quote("" . $artist);
	$album = $dbh->quote("" . $album);
	$comment = $dbh->quote("" . $comment);
	$genre = $dbh->quote("" . $genre);
	$gotdate = strftime("%Y-%m-%d", localtime(time()));
	print "\nGotDate: ".$gotdate ."\n";
	$gotdate = $dbh->quote("" . $gotdate);
	#print "\nGotDate: ".$gotdate ."\n";
	print "$title";

	$id = $dbh->{'mysql_insertid'};
	$arg = "INSERT INTO $table values \($filename, $dirname, \
	       '$rate', '$length', $title, \
     		$artist, $album, '$year', $comment, $cd, $gotdate, \
  		$genre, '$tracknum', '$copyright', '$version', \
		'$frequency', '$mode', '$layer', '$id'\)";


	#print $arg . 
	$sth = $dbh->prepare($arg);

	if ( !defined $sth ) {
    		die "Cannot prepare statement: $DBI::errstr\n";
 	 }	
	$sth->execute;
	$sth->finish;
 	print "\n\n--------------------------------\n\n";

}
